
/*
 * save_image.c 
 */
#include <stdio.h>
#include <sys/types.h>

#include <time.h>
#include <sys/time.h>

#include <sys/ipc.h>
#include <sys/shm.h>

#include "shm.h"

#include <errno.h>

void init_shm();
void show_sentry_shm();
void save_thru(int, int, char*);

key_t   sentry_shmkey;
int     sentry_shmid;
int     sentry_shm_chunk_radix;
sentry_shmrec   *sentry_shm_chunk;
sentry_shmrec   *sentry_shm_info;

void init_shm()
{
  fprintf(stderr, "init_shm:\n");

  sentry_shmkey = SENTRY_SHMKEY;
  sentry_shm_chunk_radix = SENTRY_SHM_CHUNK_RADIX;

  if ((sentry_shmid = 
       make_new_pool(sentry_shmkey, SENTRY_SHM_BLOCK_SIZE*(sentry_shm_chunk_radix+1))) < 0) {
    fprintf(stderr, "init_shm: cannot make shm: %s\n", sys_errlist[errno]);
    exit (1);
  }

  if ((sentry_shm_chunk = (sentry_shmrec *)shmat(sentry_shmid, NULL, 0)) < 0) {
    fprintf(stderr, "init_shm: fail to shmat(): %s\n", sys_errlist[errno]);
    exit (1);
  }

  sentry_shm_info = &sentry_shm_chunk[0];
  sentry_shm_info->info.last_update = -1;
  sentry_shm_info->info.radix = sentry_shm_chunk_radix;

  bzero((char *)sentry_shm_info->info.magick, 16);
  strcpy(sentry_shm_info->info.magick, "SENTRY");
  bzero((char *)sentry_shm_info->info.ver, 0);
  strcpy(sentry_shm_info->info.ver, "0.22");
  
  show_pool_stat(sentry_shmid);
  show_sentry_shm();
}

void
show_sentry_shm()
{
}

/*
 * save_thru
 */
void
save_thru(int size, int format, char *buff)
{
  static int h = 0;
  static int c = 0;
  static time_t last = -1;
  time_t now;
  int pos ;

  if (h==0) init_shm();
  h++;

  time(&now);
  if (now != last) 
    c = 0;
  else
    c ++;
  if (c != 0) return;

  pos = 1+now%sentry_shm_chunk_radix;

  fprintf(stderr, "save_thru_shm: h %8d, c %3d : now %10d -> pos %4d\n",
	  h, c, now, pos);

  sentry_shm_chunk[pos].entry.header.attr.tstamp = -1;
  memcpy(sentry_shm_chunk[pos].entry.body, buff, size);

  sentry_shm_chunk[pos].entry.header.attr.length = htonl(size);
}
