
/*
 * shm.h
 */

#ifndef _SHM_H_
#define _SHM_H_

#ifndef SENTRY_SHMKEY
#define SENTRY_SHMKEY   (97812)
#endif /* SENTRY_SHMKEY */

#ifndef SENTRY_SHM_BLOCK_SIZE
#define SENTRY_SHM_BLOCK_SIZE   (8*1024)        /* 8KB */
#endif /* SENTRY_SHM_BLOCK_SIZE */

#ifndef SENTRY_SHM_CHUNK_RADIX
#define SENTRY_SHM_CHUNK_RADIX  (256)
#endif /* SENTRY_SHM_CHUNK_RADIX */


typedef union {
  char _dummy[SENTRY_SHM_BLOCK_SIZE];

  struct {
    union {
      char __dummy[16];
      struct {
	time_t  tstamp;
	long    length;
      } attr;
    } header;
    unsigned char body[SENTRY_SHM_BLOCK_SIZE-16];
  } entry;

  struct {
    char magick[16];
    char ver[16];
    time_t last_update;
    int radix;
  } info;
} sentry_shmrec;

extern key_t    sentry_shmkey;
extern int      sentry_shmid;
extern int      sentry_shm_chunk_radix;

int make_new_pool (key_t shmkey, size_t pool_size);
int delete_pool (int shmid);
int assign_pool (key_t shmkey);    
int show_pool_stat (int shmid);

#endif /* _SHM_H_ */
