
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <errno.h>

#define	OLD
#ifdef OLD
#include <sys/time.h>
#endif

extern 	int errno;

void
mainloop(int tsock, int usock)
{
  fd_set readfds, readmask;
  int ret;
  int nr;
  char buf[256];
  struct sockaddr_in from;
  int fromlen;
  int newsockfd;
  int type;
  int typelen;
#ifdef OLD
	struct timeval tout;
#endif

  FD_ZERO(&readmask);
  FD_SET(tsock, &readmask);
  FD_SET(usock, &readmask);

	typelen = sizeof(type);

  	printf("TCP sock# %d <type %d>\n", tsock, SOCK_STREAM);
	ret = getsockopt(tsock, SOL_SOCKET, SO_TYPE, (void*)&type, &typelen);
	printf("fd# %d, type %d\n", tsock, type);

  	printf("UDP sock# %d <type %d>\n", usock, SOCK_DGRAM);
	ret = getsockopt(usock, SOL_SOCKET, SO_TYPE, (void*)&type, &typelen);
	printf("fd# %d, type %d\n", usock, type);

  while (1) {
    readfds = readmask;

#ifdef OLD
	tout.tv_sec = 2;
	tout.tv_usec = 0;
#endif

	printf("===\n");
#if 0
    ret = select(10, &readfds, (fd_set *)0, (fd_set *)0, (struct timeval *)0);
#else
    ret = select(10, &readfds, (fd_set *)0, (fd_set *)0, &tout);
#endif
    printf("ret = %d\n", ret);

	if (ret <= 0) {
		fprintf (stderr, "errno = %d\n", errno);
		perror("select");
		fprintf (stderr, "error: %s\n", sys_errlist[errno]);
		continue;
	}


	if (FD_ISSET(tsock, &readmask)) {
		printf("tsock is readable\n");
	}
	if (FD_ISSET(usock, &readmask)) {
		printf("usock is readable\n");
	}
	newsockfd = -1;

	if (FD_ISSET(tsock, &readmask)) {
		printf("TCP is arrive\n");

		newsockfd = accept(tsock, (struct sockaddr *)&from, &fromlen);
		printf("accept new fd# %d (%d)\n", newsockfd, errno);
		if(newsockfd<0) {
			goto udp_check;
		}

			printf("new connection is TCP\n");

		shutdown(newsockfd, 2);
		close(newsockfd);

		continue;
	}
udp_check:
	if (FD_ISSET(usock, &readmask)) {
		printf("UDP is arrive\n");

	  	nr = recvfrom(usock, buf, sizeof(buf), 0, (struct sockaddr *)&from, &fromlen);
		printf("recvfrom new fd# %d, %d (%d)\n", usock, nr, errno);

			printf("new connection is UDP\n");

		continue;
	}


  }
}

main()
{
  int tcpsock, udpsock;
  struct sockaddr_in me;
  int flag;

  flag = 1;

  if ((tcpsock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket: tcpsock");
    exit (1);
  }
  if(setsockopt(tcpsock, SOL_SOCKET, SO_REUSEADDR,
  (char *) &flag, sizeof(flag)) < 0) {
		perror("sesockopt");
	}
	if(fcntl(tcpsock, F_SETFL, FNDELAY)<0) {
	}



  if ((udpsock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
    perror("socket: udpsock");
    exit (1);
  }
  if(setsockopt(udpsock, SOL_SOCKET, SO_REUSEADDR,
  (char *) &flag, sizeof(flag)) < 0) {
		perror("sesockopt");
	}
	if(fcntl(udpsock, F_SETFL, FNDELAY)<0) {
	}

  bzero((char *)&me, sizeof(me));
  me.sin_family = AF_INET;
  me.sin_addr.s_addr = htonl(INADDR_ANY);
  me.sin_port = htons(9999);

  if (bind(tcpsock, (struct sockaddr *)&me, sizeof(me)) < 0) {
    perror("bind: tcpsock");
    exit (1);
  } 
#if 1
  if (bind(udpsock, (struct sockaddr *)&me, sizeof(me)) < 0) {
    perror("bind: udpsock");
    exit (1);
  } 
#endif

  listen(tcpsock, -1);
#if 1
  listen(udpsock, -1);
#endif

  (void)mainloop(tcpsock, udpsock);
}

