
/*
 * test4.c 
 *    -- check type size and learn how to use functions about time
 */
#include <stdio.h>
#include <sys/time.h>

#include <errno.h>


typedef int	tt;

main()
{
	struct timeval tv;
	time_t now;
	long ts[2];
	long long ts2;
	__int32_t sec,min,hour,day,month,year;
	tt	dummy;


	if (gettimeofday(&tv, (struct timezone *)NULL) < 0) {
		perror("gettimeofday");
		exit (1);
	}
	ts[0] = tv.tv_sec;
	ts[1] = tv.tv_usec;
	fprintf(stderr, "time# %d.%06d\n", ts[0], ts[1]);

	if (time(&now) < 0) {
		perror("time");
		exit (1);
	}
	ts[0] = now;
	ts[1] = 0; 
	fprintf(stderr, "now#  %d.%06d\n", ts[0], ts[1]);


	sec = ts[0] % 60; ts[0] = (ts[0] - sec) / 60;
	min = ts[0] % 60; ts[0] = (ts[0] - min) / 60;
	hour = ts[0] % 24; ts[0] = (ts[0] - hour) / 24;
	day = ts[0] % 365; ts[0] = (ts[0] - day) / 365;
	
	year = ts[0] + 1970;
	day += (year-year%4)/4 - (year-year%100)/100 + (year-year%400)/400 - 477;
	month = day / 30;
	/* month = (day - day % 30) / 30; */

	fprintf(stderr, "month=%7.3f\n", month);
	fprintf(stderr, "date# %d, %d, %02d/%02d, %02d:%02d:%02d\n", year, day, month, day%30, hour+9, min, sec);

	fprintf(stdout, "size# int32=%d, long=%d, long long=%d, tt=%d\n", 
		sizeof(sec), sizeof(ts[0]), sizeof(ts2), sizeof(dummy));
	
}
